VERSION 5.00
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   Caption         =   "Form1"
   ClientHeight    =   1080
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7785
   LinkTopic       =   "Form1"
   ScaleHeight     =   72
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   519
   StartUpPosition =   3  'Windows Default
   Begin VB.Shape Shape1 
      BorderColor     =   &H000000FF&
      BorderWidth     =   2
      Height          =   255
      Left            =   240
      Top             =   240
      Width           =   255
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim BlockWidth As Long

'websafe colours are made from 00/33/66/CC/FF hex
'increment by 51 (decimal) to obtain progressions
'Email: oigres@postmaster.co.uk
Private Sub Form_Load()

    BlockWidth = 12 'block size
    'looks better with 2 pixel border
    Shape1.BorderWidth = 2
    Shape1.Width = BlockWidth - 2
    Shape1.Height = BlockWidth - 2

    drawBlocks
    Form_MouseMove 0, 0, 0, 12
End Sub
Private Sub drawBlocks()
    Dim x, y, clr As Long, r, g, b
    For x = 0 To 35
        For y = 0 To 5
            clr = RGB(r, g, b)
            Form1.Line (x * BlockWidth, y * BlockWidth)-(x * BlockWidth + BlockWidth - 1, y * BlockWidth + BlockWidth - 1), clr, BF

            r = r + 51
            If r > 255 Then
                r = 0: g = g + 51
            End If
            If g > 255 Then
                g = 0: b = b + 51
            End If
            If b > 255 Then
                b = 0:
            End If
        Next

    Next
    'For y = 0 To 6
    'Form1.Line (0, y * BlockWidth)-(Form1.ScaleWidth - 1, y * BlockWidth), &HFF
    'Next
    'For x = 0 To 35
    'Form1.Line (x * BlockWidth, 0)-(x * BlockWidth, Form1.ScaleHeight), &HC0C0C0
    'Next
    
drawBorders

End Sub
Sub drawBorders()
Dim x As Integer, y As Integer
For x = 0 To 35
        For y = 0 To 5
            Form1.Line (x * BlockWidth, y * BlockWidth)-(x * BlockWidth + BlockWidth - 1, y * BlockWidth + BlockWidth - 1), &HC0C0C0, B

        Next
    Next
End Sub
Private Sub drawblocks2()
    Dim x, y, clr As Long, r As Integer, g As Integer, b As Integer
    For x = 0 To 35
        For y = 0 To 5
            clr = RGB(r, g, b)
            Form1.Line (x * BlockWidth, y * BlockWidth)-(x * BlockWidth + BlockWidth - 1, y * BlockWidth + BlockWidth - 1), clr, BF
            'clr = clr + 51
            'r = r + 51
            g = g + 51
            If g > 255 Then
                g = 0: b = b + 51
            End If
            If b > 255 Then
                b = 0: r = r + 51
            End If
            If r > 255 Then
                r = 0: 'g = g + 51
            End If

        Next
    Next
    drawBorders
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    'change the direction of the colour transitions
    Static colourtype As Boolean
    If Button = vbRightButton Then
        If colourtype = True Then
            colourtype = False
            drawBlocks
            updateInfo x, y
        Else
            colourtype = True
            drawblocks2
            updateInfo x, y
        End If
    End If
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim r, g, b
    Dim str As String
    Static lastx As Long, lasty As Long
    Dim xm  As Long, ym As Long
    xm = (x \ BlockWidth) * BlockWidth
    ym = (y \ BlockWidth) * BlockWidth

    If (lastx <> xm) Or (lasty <> ym) Then
        Form1.Caption = ""
        'adjust for 2 pixel border of shape
        Shape1.Left = xm + 1
        Shape1.Top = ym + 1
        lastx = xm: lasty = ym
        updateInfo x, y

    End If
End Sub
Private Sub updateInfo(x As Single, y As Single)
    Dim str As String
    Dim r, g, b, x2, y2
    x2 = x \ BlockWidth
    y2 = y \ BlockWidth
    
    x = ((x \ BlockWidth) * BlockWidth) + (BlockWidth \ 2)
    y = ((y \ BlockWidth) * BlockWidth) + (BlockWidth \ 2)
    
    Shape1.BorderColor = &HFFFFFF - Form1.Point(x, y)

    str = String(6, "0")
    'translate long to r g b bytes
    'colour is stored in reverse byte order
    r = (Form1.Point(x, y) And &HFF0000) \ &H10000
    g = (Form1.Point(x, y) And &HFF00&) \ &H100
    b = (Form1.Point(x, y) And &HFF&)
    Form1.Caption = "DEC " & Form1.Point(x, y)

    Mid$(str, 1, 2) = Hex$(r)
    Mid$(str, 3, 2) = Hex$(g)
    Mid$(str, 5, 2) = Hex$(b)
    'hex and block x/y and colour block number (y2 * 36) + x2 + 1
    Form1.Caption = Form1.Caption & "::HEX " & str & _
    ":" & x2 & ":" & y2 & ":" & "Block " & (y2 * 36) + x2 + 1

End Sub
Private Sub Form_Resize()
    'Dim stwx As Double, stwy As Double
    'stwx = Screen.TwipsPerPixelX
    'stwy = Screen.TwipsPerPixelY
    '6600\36 = 183:183\12=15 :12*15*36=6480
    '6600/36=183.333333333333:183.333333333333/12=15.2777777777778
    'TwipsPerPixelX returns 15:TwipsPerPixelY returns 15.. should be 20.6944444444444
    Form1.Width = 15.27 * BlockWidth * 36 '6600 ' BlockWidth * 36 * stwx
    Form1.Height = 20.7 * BlockWidth * 6


End Sub
